wayland::server::zwp_text_input_v3_t(3)

NAME
wayland::server::zwp_text_input_v3_t - text input

SYNOPSIS

#include <wayland-server-protocol-unstable.hpp>

Inherits wayland::server::resource_t.

  Public Member Functions

std::function< void()> & on_destroy ()
Destroy the wp_text_input.
std::function< void()> & on_enable ()
Request text input to be enabled.
std::function< void()> & on_disable ()
Disable text input on a surface.
std::function< void(std::string, int32_t, int32_t)> & on_set_surrounding_text ()
sets the surrounding text
std::function< void(zwp_text_input_v3_change_cause)> & on_set_text_change_cause ()
indicates the cause of surrounding text change
std::function< void(zwp_text_input_v3_content_hint, zwp_text_input_v3_content_purpose)> & on_set_content_type ()
set content purpose and hint
std::function< void(int32_t, int32_t, int32_t, int32_t)> & on_set_cursor_rectangle ()
set cursor position
std::function< void()> & on_commit ()
commit state
void enter (surface_t const &surface, bool post=true)
enter event
void leave (surface_t const &surface, bool post=true)
leave event
void preedit_string (std::string const &text, int32_t cursor_begin, int32_t cursor_end, bool post=true)
pre-edit
void commit_string (std::string const &text, bool post=true)
text commit
void delete_surrounding_text (uint32_t before_length, uint32_t after_length, bool post=true)
delete surrounding text
void done (uint32_t serial, bool post=true)
apply changes
bool proxy_has_object () const
Check whether this wrapper actually wraps an object.
void post_no_memory () const
uint32_t get_id () const
client_t get_client () const
unsigned int get_version () const
std::string get_class ()

  Static Public Attributes

static constexpr std::uint32_t enter_since_version = 1
Minimum protocol version required for the enter function.
static constexpr std::uint32_t leave_since_version = 1
Minimum protocol version required for the leave function.
static constexpr std::uint32_t preedit_string_since_version = 1
Minimum protocol version required for the preedit_string function.
static constexpr std::uint32_t commit_string_since_version = 1
Minimum protocol version required for the commit_string function.
static constexpr std::uint32_t delete_surrounding_text_since_version = 1
Minimum protocol version required for the delete_surrounding_text function.
static constexpr std::uint32_t done_since_version = 1
Minimum protocol version required for the done function.

Detailed Description

text input

The zwp_text_input_v3 interface represents text input and input methods associated with a seat. It provides enter/leave events to follow the text input focus for a seat.

Requests are used to enable/disable the text-input object and set state information like surrounding and selected text or the content type. The information about the entered text is sent to the text-input object via the preedit_string and commit_string events.

Text is valid UTF-8 encoded, indices and lengths are in bytes. Indices must not point to middle bytes inside a code point: they must either point to the first byte of a code point or to the end of the buffer. Lengths must be measured between two valid indices.

Focus moving throughout surfaces will result in the emission of zwp_text_input_v3.enter and zwp_text_input_v3.leave events. The focused surface must commit zwp_text_input_v3.enable and zwp_text_input_v3.disable requests as the keyboard focus moves across editable and non-editable elements of the UI. Those two requests are not expected to be paired with each other, the compositor must be able to handle consecutive series of the same request.

State is sent by the state requests (set_surrounding_text, set_content_type and set_cursor_rectangle) and a commit request. After an enter event or disable request all state information is invalidated and needs to be resent by the client.

Definition at line 6986 of file wayland-server-protocol-unstable.hpp.

Member Function Documentation

  void zwp_text_input_v3_t::commit_string (std::string const & text, bool post = true)

text commit

Parameters
    text

Notify when text should be inserted into the editor widget. The text to commit could be either just a single character after a key press or the result of some composing (pre-edit).

Values set with this event are double-buffered. They must be applied and reset to initial on the next zwp_text_input_v3.done event.

The initial value of text is an empty string.

Definition at line 7296 of file wayland-server-protocol-unstable.cpp.

  void zwp_text_input_v3_t::delete_surrounding_text (uint32_t before_length, uint32_t after_length, bool post = true)

delete surrounding text

Parameters
    before_length length of text before current cursor position
    after_length length of text after current cursor position

Notify when the text around the current cursor position should be deleted.

Before_length and after_length are the number of bytes before and after the current cursor index (excluding the selection) to delete.

If a preedit text is present, in effect before_length is counted from the beginning of it, and after_length from its end (see done event sequence).

Values set with this event are double-buffered. They must be applied and reset to initial on the next zwp_text_input_v3.done event.

The initial values of both before_length and after_length are 0.

Definition at line 7301 of file wayland-server-protocol-unstable.cpp.

  void zwp_text_input_v3_t::done (uint32_t serial, bool post = true)

apply changes

Parameters
    serial

Instruct the application to apply changes to state requested by the preedit_string, commit_string and delete_surrounding_text events. The state relating to these events is double-buffered, and each one modifies the pending state. This event replaces the current state with the pending state.

The application must proceed by evaluating the changes in the following order:

1.  Replace existing preedit string with the cursor.

2.  Delete requested surrounding text.

3.  Insert commit string with the cursor at its end.

4.  Calculate surrounding text to send.

5.  Insert new preedit text in cursor position.

6.  Place cursor inside preedit text.

The serial number reflects the last state of the zwp_text_input_v3 object known to the compositor. The value of the serial argument must be equal to the number of commit requests already issued on that object. When the client receives a done event with a serial different than the number of past commit requests, it must proceed as normal, except it should not change the current state of the zwp_text_input_v3 object.

Definition at line 7306 of file wayland-server-protocol-unstable.cpp.

  void zwp_text_input_v3_t::enter (surface_t const & surface, bool post = true)

enter event

Parameters
    surface

Notification that this seat's text-input focus is on a certain surface.

If client has created multiple text input objects, compositor must send this event to all of them.

When the seat has the keyboard capability the text-input focus follows the keyboard focus. This event sets the current surface for the text-input object.

Definition at line 7281 of file wayland-server-protocol-unstable.cpp.

  std::string wayland::server::resource_t::get_class () [inherited]
Retrieve the interface name (class) of a resource object.

Returns
    Interface name of the resource object.

  client_t wayland::server::resource_t::get_client () const [inherited]
Get the associated client

Returns
    the client that owns the resource.

  uint32_t wayland::server::resource_t::get_id () const [inherited]
Get the internal ID of the resource

Returns
    the internal ID of the resource

  unsigned int wayland::server::resource_t::get_version () const [inherited]
Get interface version

Returns
    Interface version this resource has been constructed with.

  void zwp_text_input_v3_t::leave (surface_t const & surface, bool post = true)

leave event

Parameters
    surface

Notification that this seat's text-input focus is no longer on a certain surface. The client should reset any preedit string previously set.

The leave notification clears the current surface. It is sent before the enter notification for the new focus. After leave event, compositor must ignore requests from any text input instances until next enter event.

When the seat has the keyboard capability the text-input focus follows the keyboard focus.

Definition at line 7286 of file wayland-server-protocol-unstable.cpp.

  std::function< void()> & zwp_text_input_v3_t::on_commit ()

commit state Atomically applies state changes recently sent to the compositor.

The commit request establishes and updates the state of the client, and must be issued after any changes to apply them.

Text input state (enabled status, content purpose, content hint, surrounding text and change cause, cursor rectangle) is conceptually double-buffered within the context of a text input, i.e. between a committed enable request and the following committed enable or disable request.

Protocol requests modify the pending state, as opposed to the current state in use by the input method. A commit request atomically applies all pending state, replacing the current state. After commit, the new pending state is as documented for each related request.

Requests are applied in the order of arrival.

Neither current nor pending state are modified unless noted otherwise.

The compositor must count the number of commit requests coming from each zwp_text_input_v3 object and use the count as the serial in done events.

Definition at line 7275 of file wayland-server-protocol-unstable.cpp.

  std::function< void()> & zwp_text_input_v3_t::on_destroy ()

Destroy the wp_text_input. Destroy the wp_text_input object. Also disables all surfaces enabled through this wp_text_input object.

Definition at line 7233 of file wayland-server-protocol-unstable.cpp.

  std::function< void()> & zwp_text_input_v3_t::on_disable ()

Disable text input on a surface. Explicitly disable text input on the current surface (typically when there is no focus on any text entry inside the surface).

State set with this request is double-buffered. It will get applied on the next zwp_text_input_v3.commit request.

Definition at line 7245 of file wayland-server-protocol-unstable.cpp.

  std::function< void()> & zwp_text_input_v3_t::on_enable ()

Request text input to be enabled. Requests text input on the surface previously obtained from the enter event.

This request must be issued every time the active text input changes to a new one, including within the current surface. Use zwp_text_input_v3.disable when there is no longer any input focus on the current surface.

Clients must not enable more than one text input on the single seat and should disable the current text input before enabling the new one. At most one instance of text input may be in enabled state per instance, Requests to enable the another text input when some text input is active must be ignored by compositor.

This request resets all state associated with previous enable, disable, set_surrounding_text, set_text_change_cause, set_content_type, and set_cursor_rectangle requests, as well as the state associated with preedit_string, commit_string, and delete_surrounding_text events.

The set_surrounding_text, set_content_type and set_cursor_rectangle requests must follow if the text input supports the necessary functionality.

State set with this request is double-buffered. It will get applied on the next zwp_text_input_v3.commit request, and stay valid until the next committed enable or disable request.

The changes must be applied by the compositor after issuing a zwp_text_input_v3.commit request.

Definition at line 7239 of file wayland-server-protocol-unstable.cpp.

  std::function< void(zwp_text_input_v3_content_hint, zwp_text_input_v3_content_purpose)> & zwp_text_input_v3_t::on_set_content_type ()

set content purpose and hint

Parameters
    hint
    purpose

Sets the content purpose and content hint. While the purpose is the basic purpose of an input field, the hint flags allow to modify some of the behavior.

Values set with this request are double-buffered. They will get applied on the next zwp_text_input_v3.commit request. Subsequent attempts to update them may have no effect. The values remain valid until the next committed enable or disable request.

The initial value for hint is none, and the initial value for purpose is normal.

Definition at line 7263 of file wayland-server-protocol-unstable.cpp.

  std::function< void(int32_t, int32_t, int32_t, int32_t)> & zwp_text_input_v3_t::on_set_cursor_rectangle ()

set cursor position

Parameters
    x
    y
    width
    height

Marks an area around the cursor as a x, y, width, height rectangle in surface local coordinates.

Allows the compositor to put a window with word suggestions near the cursor, without obstructing the text being input.

If the client is unaware of the position of edited text, it should not issue this request, to signify lack of support to the compositor.

Values set with this request are double-buffered. They will get applied on the next zwp_text_input_v3.commit request, and stay valid until the next committed enable or disable request.

The initial values describing a cursor rectangle are empty. That means the text input does not support describing the cursor area. If the empty values get applied, subsequent attempts to change them may have no effect.

Definition at line 7269 of file wayland-server-protocol-unstable.cpp.

  std::function< void(std::string, int32_t, int32_t)> & zwp_text_input_v3_t::on_set_surrounding_text ()

sets the surrounding text

Parameters
    text
    cursor
    anchor

Sets the surrounding plain text around the input, excluding the preedit text.

The client should notify the compositor of any changes in any of the values carried with this request, including changes caused by handling incoming text-input events as well as changes caused by other mechanisms like keyboard typing.

If the client is unaware of the text around the cursor, it should not issue this request, to signify lack of support to the compositor.

Text is UTF-8 encoded, and should include the cursor position, the complete selection and additional characters before and after them. There is a maximum length of wayland messages, so text can not be longer than 4000 bytes.

Cursor is the byte offset of the cursor within text buffer.

Anchor is the byte offset of the selection anchor within text buffer. If there is no selected text, anchor is the same as cursor.

If any preedit text is present, it is replaced with a cursor for the purpose of this event.

Values set with this request are double-buffered. They will get applied on the next zwp_text_input_v3.commit request, and stay valid until the next committed enable or disable request.

The initial state for affected fields is empty, meaning that the text input does not support sending surrounding text. If the empty values get applied, subsequent attempts to change them may have no effect.

Definition at line 7251 of file wayland-server-protocol-unstable.cpp.

  std::function< void(zwp_text_input_v3_change_cause)> & zwp_text_input_v3_t::on_set_text_change_cause ()

indicates the cause of surrounding text change

Parameters
    cause

Tells the compositor why the text surrounding the cursor changed.

Whenever the client detects an external change in text, cursor, or anchor posision, it must issue this request to the compositor. This request is intended to give the input method a chance to update the preedit text in an appropriate way, e.g. by removing it when the user starts typing with a keyboard.

cause describes the source of the change.

The value set with this request is double-buffered. It must be applied and reset to initial at the next zwp_text_input_v3.commit request.

The initial value of cause is input_method.

Definition at line 7257 of file wayland-server-protocol-unstable.cpp.

  void wayland::server::resource_t::post_no_memory () const [inherited]
Post 'not enough memory' error to the client

If the compositor has not enough memory to fulfill a certail request of the client, this function can be called to notify the client of this circumstance.

  void zwp_text_input_v3_t::preedit_string (std::string const & text, int32_t cursor_begin, int32_t cursor_end, bool post = true)

pre-edit

Parameters
    text
    cursor_begin
    cursor_end

Notify when a new composing text (pre-edit) should be set at the current cursor position. Any previously set composing text must be removed. Any previously existing selected text must be removed.

The argument text contains the pre-edit string buffer.

The parameters cursor_begin and cursor_end are counted in bytes relative to the beginning of the submitted text buffer. Cursor should be hidden when both are equal to -1.

They could be represented by the client as a line if both values are the same, or as a text highlight otherwise.

Values set with this event are double-buffered. They must be applied and reset to initial on the next zwp_text_input_v3.done event.

The initial value of text is an empty string, and cursor_begin, cursor_end and cursor_hidden are all 0.

Definition at line 7291 of file wayland-server-protocol-unstable.cpp.

  bool wayland::server::resource_t::proxy_has_object () const [inherited]

Check whether this wrapper actually wraps an object.

Returns
    true if there is an underlying object, false if this wrapper is empty

Member Data Documentation

  constexpr std::uint32_t wayland::server::zwp_text_input_v3_t::commit_string_since_version = 1 [static], [constexpr]

Minimum protocol version required for the commit_string function.

Definition at line 7298 of file wayland-server-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::server::zwp_text_input_v3_t::delete_surrounding_text_since_version = 1 [static], [constexpr]

Minimum protocol version required for the delete_surrounding_text function.

Definition at line 7324 of file wayland-server-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::server::zwp_text_input_v3_t::done_since_version = 1 [static], [constexpr]

Minimum protocol version required for the done function.

Definition at line 7357 of file wayland-server-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::server::zwp_text_input_v3_t::enter_since_version = 1 [static], [constexpr]

Minimum protocol version required for the enter function.

Definition at line 7226 of file wayland-server-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::server::zwp_text_input_v3_t::leave_since_version = 1 [static], [constexpr]

Minimum protocol version required for the leave function.

Definition at line 7248 of file wayland-server-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::server::zwp_text_input_v3_t::preedit_string_since_version = 1 [static], [constexpr]

Minimum protocol version required for the preedit_string function.

Definition at line 7279 of file wayland-server-protocol-unstable.hpp.

Author

Generated automatically by Doxygen for Wayland++ from the source code.